/*!
* Copyright Adaptavist 2022 (c) All rights reserved
*/
import { getHeaders } from "@managed-api/commons-core";
export function constructHeaders(body, manualHeaders) {
    return getHeaders(body, manualHeaders);
}
export function URLEncodeBodyWithDuplicateValues(body) {
    const encodedBody = new URLSearchParams();
    for (const key in body) {
        const value = body[key];
        if (Array.isArray(value)) {
            for (const element of value) {
                encodedBody.append(key, element);
            }
        }
        else {
            encodedBody.append(key, value);
        }
    }
    return encodedBody;
}
export async function errorMessageBuilder(response, reason) {
    var _a, _b;
    try {
        const errors = await response.json();
        const errorMessage = ((_a = errors.error) === null || _a === void 0 ? void 0 : _a.message) || errors.message;
        const detail = (_b = errors.error) === null || _b === void 0 ? void 0 : _b.detail;
        if (errorMessage) {
            return `${reason} - ${errorMessage}${detail ? `: ${detail}` : ""}`;
        }
    }
    catch { }
    return reason;
}
//# sourceMappingURL=common.js.map