/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
export declare type AccountAsResponse = ObjectAsResponse & {
    links?: {
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        html?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        avatar?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        followers?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        following?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        repositories?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        snippets?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        hooks?: {
            href?: string;
            name?: string;
        };
    };
    username?: string;
    /**
     * Account name defined by the owner. Should be used instead of the "username" field. Note that "nickname" cannot be used in place of "username" in URLs and queries, as "nickname" is not guaranteed to be unique.
     */
    nickname?: string;
    account_id?: string;
    /**
     * The status of the account. Currently the only possible value is "active", but more values may be added in the future.
     */
    account_status?: string;
    display_name?: string;
    website?: string | null;
    created_on?: string;
    location?: string | null;
    uuid?: string;
    has_2fa_enabled?: boolean | null;
    [x: string]: any;
};
//# sourceMappingURL=AccountAsResponse.d.ts.map