/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { Object } from "../definitions/Object";
export declare type Author = Object & {
    /**
     * The raw author value from the repository. This may be the only value available if the author does not match a user in Bitbucket.
     */
    raw?: string;
    user?: {
        links?: {
            /**
             * A link to a resource related to this object.
             */
            self?: {
                href?: string;
                name?: string;
            };
            /**
             * A link to a resource related to this object.
             */
            html?: {
                href?: string;
                name?: string;
            };
            /**
             * A link to a resource related to this object.
             */
            avatar?: {
                href?: string;
                name?: string;
            };
        };
        display_name?: string;
        uuid?: string;
        nickname?: string;
        account_id?: string;
        type: string;
    };
    [x: string]: any;
};
//# sourceMappingURL=Author.d.ts.map