/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { LinksAsResponse } from "../definitions/LinksAsResponse";
import { AuthorAsResponse } from "../definitions/AuthorAsResponse";
import { CommitterAsResponse } from "../definitions/CommitterAsResponse";
export declare type BaseCommitAsResponse = ObjectAsResponse & {
    rendered?: {
        message?: {
            /**
             * The text as it was typed by a user.
             */
            raw?: string;
            /**
             * The type of markup language the raw content is to be interpreted in.
             */
            markup?: string;
            /**
             * The user's content rendered as HTML.
             */
            html?: string;
            type?: string;
        };
    };
    links?: LinksAsResponse;
    hash?: string;
    date?: string;
    author?: AuthorAsResponse;
    message?: string;
    summary?: {
        /**
         * The text as it was typed by a user.
         */
        raw?: string;
        /**
         * The type of markup language the raw content is to be interpreted in.
         */
        markup?: "markdown" | "creole" | "plaintext";
        /**
         * The user's content rendered as HTML.
         */
        html?: string;
        type?: string;
    };
    parents?: Array<BaseCommitAsResponse>;
    properties?: {
        [x: string]: any;
    };
    committer?: CommitterAsResponse;
    repository?: {
        links?: {
            /**
             * A link to a resource related to this object.
             */
            self?: {
                href?: string;
                name?: string;
            };
            /**
             * A link to a resource related to this object.
             */
            html?: {
                href?: string;
                name?: string;
            };
            /**
             * A link to a resource related to this object.
             */
            avatar?: {
                href?: string;
                name?: string;
            };
        };
        /**
         * The concatenation of the repository owner's username and the slugified name, e.g. "evzijst/interruptingcow". This is the same string used in Bitbucket URLs.
         */
        full_name?: string;
        name?: string;
        /**
         * The repository's immutable id. This can be used as a substitute for the slug segment in URLs. Doing this guarantees your URLs will survive renaming of the repository by its owner, or even transfer of the repository to a different user.
         */
        uuid?: string;
        type?: string;
    };
    [x: string]: any;
};
//# sourceMappingURL=BaseCommitAsResponse.d.ts.map