/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { Object } from "../definitions/Object";
import { Commit } from "../definitions/Commit";
export declare type Branch = Object & {
    links?: {
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        commits?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        html?: {
            href?: string;
            name?: string;
        };
    };
    /**
     * The name of the ref.
     */
    name?: string;
    target?: Commit;
    /**
     * Available merge strategies for pull requests targeting this branch.
     */
    merge_strategies?: Array<"merge_commit" | "squash" | "fast_forward" | "squash_fast_forward" | "rebase_fast_forward" | "rebase_merge">;
    /**
     * The default merge strategy for pull requests targeting this branch.
     */
    default_merge_strategy?: string;
    [x: string]: any;
};
//# sourceMappingURL=Branch.d.ts.map