/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { AccountAsResponse } from "../definitions/AccountAsResponse";
export declare type CommentAsResponse = ObjectAsResponse & {
    id?: number;
    created_on?: string;
    updated_on?: string;
    content?: {
        /**
         * The text as it was typed by a user.
         */
        raw?: string;
        /**
         * The type of markup language the raw content is to be interpreted in.
         */
        markup?: "markdown" | "creole" | "plaintext";
        /**
         * The user's content rendered as HTML.
         */
        html?: string;
        type?: string;
    };
    user?: AccountAsResponse;
    deleted?: boolean;
    parent?: CommentAsResponse;
    inline?: {
        /**
         * The comment's anchor line in the new version of the file. If the 'from' line is also provided, this value will be removed.
         */
        to?: number | null;
        /**
         * The comment's anchor line in the old version of the file.
         */
        from?: number | null;
        /**
         * The path of the file this comment is anchored to.
         */
        path: string;
    };
    links?: {
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        html?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        code?: {
            href?: string;
            name?: string;
        };
    };
    [x: string]: any;
};
//# sourceMappingURL=CommentAsResponse.d.ts.map