/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { BaseCommitAsResponse } from "../definitions/BaseCommitAsResponse";
import { ParticipantAsResponse } from "../definitions/ParticipantAsResponse";
export declare type CommitAsResponse = BaseCommitAsResponse & {
    repository?: {
        links?: {
            /**
             * A link to a resource related to this object.
             */
            self?: {
                href?: string;
                name?: string;
            };
            /**
             * A link to a resource related to this object.
             */
            html?: {
                href?: string;
                name?: string;
            };
            /**
             * A link to a resource related to this object.
             */
            avatar?: {
                href?: string;
                name?: string;
            };
        };
        /**
         * The concatenation of the repository owner's username and the slugified name, e.g. "evzijst/interruptingcow". This is the same string used in Bitbucket URLs.
         */
        full_name?: string;
        name?: string;
        /**
         * The repository's immutable id. This can be used as a substitute for the slug segment in URLs. Doing this guarantees your URLs will survive renaming of the repository by its owner, or even transfer of the repository to a different user.
         */
        uuid?: string;
        type?: string;
    };
    participants?: Array<ParticipantAsResponse>;
    [x: string]: any;
};
//# sourceMappingURL=CommitAsResponse.d.ts.map