/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
export declare type CommitFileAsResponse = ObjectAsResponse & {
    links?: {
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        meta?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        history?: {
            href?: string;
            name?: string;
        };
    };
    /**
     * The path in the repository
     */
    path?: string;
    commit?: {
        links?: {
            /**
             * A link to a resource related to this object.
             */
            self?: {
                href?: string;
                name?: string;
            };
            /**
             * A link to a resource related to this object.
             */
            html?: {
                href?: string;
                name?: string;
            };
        };
        hash?: string;
        type?: string;
    };
    attributes?: Array<"link" | "executable" | "subrepository" | "binary" | "lfs">;
    size?: number;
    /**
     * The escaped version of the path as it appears in a diff. If the path does not require escaping this will be the same as path.
     */
    escaped_path?: string;
    [x: string]: any;
};
//# sourceMappingURL=CommitFileAsResponse.d.ts.map