/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { DeploymentStateAsResponse } from "../definitions/DeploymentStateAsResponse";
import { DeploymentStateCompletedStatusSuccessfulAsResponse } from "../definitions/DeploymentStateCompletedStatusSuccessfulAsResponse";
import { DeploymentStateCompletedStatusStoppedAsResponse } from "../definitions/DeploymentStateCompletedStatusStoppedAsResponse";
import { DeploymentStateCompletedStatusFailedAsResponse } from "../definitions/DeploymentStateCompletedStatusFailedAsResponse";
import { DeploymentStateCompletedAsResponse } from "../definitions/DeploymentStateCompletedAsResponse";
import { DeploymentStateCompletedStatusAsResponse } from "../definitions/DeploymentStateCompletedStatusAsResponse";
import { DeploymentStateInProgressAsResponse } from "../definitions/DeploymentStateInProgressAsResponse";
import { DeploymentStateUndeployedAsResponse } from "../definitions/DeploymentStateUndeployedAsResponse";
import { DeploymentEnvironmentAsResponse } from "../definitions/DeploymentEnvironmentAsResponse";
import { DeploymentReleaseAsResponse } from "../definitions/DeploymentReleaseAsResponse";
import { LinksAsResponse } from "../definitions/LinksAsResponse";
export declare type DeploymentAsResponse = ObjectAsResponse & {
    /**
     * The UUID identifying the deployment.
     */
    uuid?: string;
    state?: DeploymentStateAsResponse | DeploymentStateCompletedStatusSuccessfulAsResponse | DeploymentStateCompletedStatusStoppedAsResponse | DeploymentStateCompletedStatusFailedAsResponse | DeploymentStateCompletedAsResponse | DeploymentStateCompletedStatusAsResponse | DeploymentStateInProgressAsResponse | DeploymentStateUndeployedAsResponse;
    last_update_time?: string;
    environment?: DeploymentEnvironmentAsResponse;
    release?: DeploymentReleaseAsResponse;
    key?: string;
    number?: number;
    version?: number;
    step?: {
        uuid?: string;
    };
    deployable?: {
        type?: string;
        uuid?: string;
        key?: string;
        name?: string;
        url?: string;
        created_on?: string;
        pipeline?: {
            uuid?: string;
            type?: string;
        };
        commit?: {
            type?: string;
            hash?: string;
            links?: LinksAsResponse;
        };
    };
    [x: string]: any;
};
//# sourceMappingURL=DeploymentAsResponse.d.ts.map