/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { CommitAsResponse } from "../definitions/CommitAsResponse";
export declare type DeploymentReleaseAsResponse = ObjectAsResponse & {
    /**
     * The UUID identifying the release.
     */
    uuid?: string;
    /**
     * The name of the release.
     */
    name?: string;
    /**
     * Link to the pipeline that produced the release.
     */
    url?: string;
    commit?: CommitAsResponse;
    /**
     * The timestamp when the release was created.
     */
    created_on?: string;
    key?: string;
    pipeline?: {
        uuid?: string;
        type?: string;
    };
    [x: string]: any;
};
//# sourceMappingURL=DeploymentReleaseAsResponse.d.ts.map