/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
export declare type DeploymentVariableAsResponse = {
    /**
     * The UUID identifying the variable.
     */
    uuid?: string;
    /**
     * The UUID identifying the workspace.
     */
    accountUuid?: string;
    /**
     * The UUID identifying the environment.
     */
    environmentUuid?: string;
    /**
     * The UUID identifying the repository.
     */
    repositoryUuid?: string;
    /**
     * The unique name of the variable.
     */
    key?: string;
    /**
     * The value of the variable. If the variable is secured, this will be empty.
     */
    value?: string;
    /**
     * If true, this variable will be treated as secured. The value will never be exposed in the logs or the REST API.
     */
    secured?: boolean;
    [x: string]: any;
};
//# sourceMappingURL=DeploymentVariableAsResponse.d.ts.map