/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { AccountAsResponse } from "../definitions/AccountAsResponse";
import { WorkspaceAsResponse } from "../definitions/WorkspaceAsResponse";
export declare type GroupAsResponse = ObjectAsResponse & {
    links?: {
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        html?: {
            href?: string;
            name?: string;
        };
    };
    owner?: AccountAsResponse;
    workspace?: WorkspaceAsResponse;
    name?: string;
    /**
  * The "sluggified" version of the group's name. This contains only ASCII
  characters and can therefore be slightly different than the name
  */
    slug?: string;
    /**
  * The concatenation of the workspace's slug and the group's slug,
  separated with a colon (e.g. `acme:developers`)
  
  */
    full_slug?: string;
    default_permission?: string;
    email_forwarding_disabled?: boolean;
    account_privilege?: string;
    [x: string]: any;
};
//# sourceMappingURL=GroupAsResponse.d.ts.map