/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { AccountAsResponse } from "../definitions/AccountAsResponse";
export declare type ParticipantAsResponse = ObjectAsResponse & {
    user?: AccountAsResponse;
    role?: "PARTICIPANT" | "REVIEWER";
    approved?: boolean;
    state?: string | null;
    /**
     * The ISO8601 timestamp of the participant's action. For approvers, this is the time of their approval. For commenters and pull request reviewers who are not approvers, this is the time they last commented, or null if they have not commented.
     */
    participated_on?: string | null;
    [x: string]: any;
};
//# sourceMappingURL=ParticipantAsResponse.d.ts.map