/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { Object } from "../definitions/Object";
import { Account } from "../definitions/Account";
import { Repository } from "../definitions/Repository";
import { PipelineTarget } from "../definitions/PipelineTarget";
import { PipelineTrigger } from "../definitions/PipelineTrigger";
import { PipelineState } from "../definitions/PipelineState";
import { PipelineVariable } from "../definitions/PipelineVariable";
import { PipelineConfigurationSource } from "../definitions/PipelineConfigurationSource";
import { PipelinesPipelineLinks } from "../definitions/PipelinesPipelineLinks";
export declare type Pipeline = Object & {
    /**
     * The UUID identifying the pipeline.
     */
    uuid?: string;
    /**
     * The build number of the pipeline.
     */
    build_number?: number;
    creator?: Account;
    repository?: Repository;
    target?: PipelineTarget;
    trigger?: PipelineTrigger;
    state?: PipelineState;
    /**
     * The variables for the pipeline.
     */
    variables?: Array<PipelineVariable>;
    /**
     * The timestamp when the pipeline was created.
     */
    created_on?: string;
    /**
     * The timestamp when the Pipeline was completed. This is not set if the pipeline is still in progress.
     */
    completed_on?: string;
    /**
     * The number of build seconds used by this pipeline.
     */
    build_seconds_used?: number;
    /**
     * An ordered list of sources of the pipeline configuration
     */
    configuration_sources?: Array<PipelineConfigurationSource>;
    links?: PipelinesPipelineLinks;
    [x: string]: any;
};
//# sourceMappingURL=Pipeline.d.ts.map