/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { AccountAsResponse } from "../definitions/AccountAsResponse";
import { RepositoryAsResponse } from "../definitions/RepositoryAsResponse";
import { PipelineTargetAsResponse } from "../definitions/PipelineTargetAsResponse";
import { PipelineTriggerAsResponse } from "../definitions/PipelineTriggerAsResponse";
import { PipelineStateAsResponse } from "../definitions/PipelineStateAsResponse";
import { PipelineVariableAsResponse } from "../definitions/PipelineVariableAsResponse";
import { PipelineConfigurationSourceAsResponse } from "../definitions/PipelineConfigurationSourceAsResponse";
import { PipelinesPipelineLinksAsResponse } from "../definitions/PipelinesPipelineLinksAsResponse";
export declare type PipelineAsResponse = ObjectAsResponse & {
    /**
     * The UUID identifying the pipeline.
     */
    uuid?: string;
    /**
     * The build number of the pipeline.
     */
    build_number?: number;
    creator?: AccountAsResponse;
    repository?: RepositoryAsResponse;
    target?: PipelineTargetAsResponse;
    trigger?: PipelineTriggerAsResponse;
    state?: PipelineStateAsResponse;
    /**
     * The variables for the pipeline.
     */
    variables?: Array<PipelineVariableAsResponse>;
    /**
     * The timestamp when the pipeline was created.
     */
    created_on?: string;
    /**
     * The timestamp when the Pipeline was completed. This is not set if the pipeline is still in progress.
     */
    completed_on?: string;
    /**
     * The number of build seconds used by this pipeline.
     */
    build_seconds_used?: number;
    /**
     * An ordered list of sources of the pipeline configuration
     */
    configuration_sources?: Array<PipelineConfigurationSourceAsResponse>;
    links?: PipelinesPipelineLinksAsResponse;
    [x: string]: any;
};
//# sourceMappingURL=PipelineAsResponse.d.ts.map