/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { PipelineRefTargetAsResponse } from "../definitions/PipelineRefTargetAsResponse";
export declare type PipelineScheduleAsResponse = ObjectAsResponse & {
    /**
     * The UUID identifying the schedule.
     */
    uuid?: string;
    /**
     * Whether the schedule is enabled.
     */
    enabled?: boolean;
    target?: PipelineRefTargetAsResponse;
    /**
     * The cron expression with second precision (7 fields) that the schedule applies. For example, for expression: 0 0 12 * * ? *, will execute at 12pm UTC every day.
     */
    cron_pattern?: string;
    /**
     * The timestamp when the schedule was created.
     */
    created_on?: string;
    /**
     * The timestamp when the schedule was updated.
     */
    updated_on?: string;
    [x: string]: any;
};
//# sourceMappingURL=PipelineScheduleAsResponse.d.ts.map