/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { Object } from "../definitions/Object";
import { PipelineSelector } from "../definitions/PipelineSelector";
export declare type PipelineSchedulePostRequestBody = Object & {
    /**
     * The target on which the schedule will be executed.
     */
    target: {
        selector: PipelineSelector;
        /**
         * The name of the reference.
         */
        ref_name: string;
        /**
         * The type of reference (branch only).
         */
        ref_type: "branch";
    };
    /**
     * Whether the schedule is enabled.
     */
    enabled?: boolean;
    /**
     * The cron expression with second precision (7 fields) that the schedule applies. For example, for expression: 0 0 12 * * ? *, will execute at 12pm UTC every day.
     */
    cron_pattern: string;
    [x: string]: any;
};
//# sourceMappingURL=PipelineSchedulePostRequestBody.d.ts.map