/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { PipelineStepStateAsResponse } from "../definitions/PipelineStepStateAsResponse";
import { PipelineImageAsResponse } from "../definitions/PipelineImageAsResponse";
import { PipelineCommandAsResponse } from "../definitions/PipelineCommandAsResponse";
export declare type PipelineStepAsResponse = ObjectAsResponse & {
    /**
     * The UUID identifying the step.
     */
    uuid?: string;
    /**
     * The timestamp when the step execution was started. This is not set when the step hasn't executed yet.
     */
    started_on?: string;
    /**
     * The timestamp when the step execution was completed. This is not set if the step is still in progress.
     */
    completed_on?: string;
    state?: PipelineStepStateAsResponse;
    image?: PipelineImageAsResponse;
    /**
     * The list of commands that are executed as part of the setup phase of the build. These commands are executed outside the build container.
     */
    setup_commands?: Array<PipelineCommandAsResponse>;
    /**
     * The list of build commands. These commands are executed in the build container.
     */
    script_commands?: Array<PipelineCommandAsResponse>;
    [x: string]: any;
};
//# sourceMappingURL=PipelineStepAsResponse.d.ts.map