/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
export declare type PipelineVariableAsResponse = ObjectAsResponse & {
    /**
     * The UUID identifying the variable.
     */
    uuid?: string;
    /**
     * The unique name of the variable.
     */
    key?: string;
    /**
     * The value of the variable. If the variable is secured, this will be empty.
     */
    value?: string;
    /**
     * If true, this variable will be treated as secured. The value will never be exposed in the logs or the REST API.
     */
    secured?: boolean;
    system?: boolean;
    scope?: string;
    [x: string]: any;
};
//# sourceMappingURL=PipelineVariableAsResponse.d.ts.map