/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { TeamAsResponse } from "../definitions/TeamAsResponse";
export declare type ProjectAsResponse = ObjectAsResponse & {
    links?: {
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        html?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        avatar?: {
            href?: string;
            name?: string;
        };
    };
    /**
     * The project's immutable id.
     */
    uuid?: string;
    /**
     * The project's key.
     */
    key?: string;
    owner?: TeamAsResponse;
    /**
     * The name of the project.
     */
    name?: string;
    description?: string;
    /**
  *
  Indicates whether the project is publicly accessible, or whether it is
  private to the team and consequently only visible to team members.
  Note that private projects cannot contain public repositories.
  */
    is_private?: boolean;
    created_on?: string;
    updated_on?: string;
    /**
  *
  Indicates whether the project contains publicly visible repositories.
  Note that private projects cannot contain public repositories.
  */
    has_publicly_visible_repos?: boolean;
    [x: string]: any;
};
//# sourceMappingURL=ProjectAsResponse.d.ts.map