/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { Repository } from "../definitions/Repository";
export interface PullrequestEndpoint {
    repository?: Repository;
    branch?: {
        name?: string;
        /**
         * Available merge strategies, when this endpoint is the destination of the pull request.
         */
        merge_strategies?: Array<"merge_commit" | "squash" | "fast_forward" | "squash_fast_forward" | "rebase_fast_forward" | "rebase_merge">;
        /**
         * The default merge strategy, when this endpoint is the destination of the pull request.
         */
        default_merge_strategy?: string;
    };
    commit?: {
        hash?: string;
    };
}
//# sourceMappingURL=PullrequestEndpoint.d.ts.map