/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
export interface PullrequestMergeParameters {
    type: string;
    /**
     * The commit message that will be used on the resulting commit. Note that the size of the message is limited to 128 KiB.
     */
    message?: string;
    /**
     * Whether the source branch should be deleted. If this is not provided, we fallback to the value used when the pull request was created, which defaults to False
     */
    close_source_branch?: boolean;
    /**
     * The merge strategy that will be used to merge the pull request.
     */
    merge_strategy?: "merge_commit" | "squash" | "fast_forward" | "squash_fast_forward" | "rebase_fast_forward" | "rebase_merge";
    [x: string]: any;
}
//# sourceMappingURL=PullrequestMergeParameters.d.ts.map