/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { Object } from "../definitions/Object";
import { Account } from "../definitions/Account";
import { Project } from "../definitions/Project";
import { Branch } from "../definitions/Branch";
export declare type Repository = Object & {
    links?: {
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        html?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        avatar?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        pullrequests?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        commits?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        forks?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        watchers?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        downloads?: {
            href?: string;
            name?: string;
        };
        clone?: Array<{
            href?: string;
            name?: string;
        }>;
        /**
         * A link to a resource related to this object.
         */
        hooks?: {
            href?: string;
            name?: string;
        };
    };
    /**
     * The repository's immutable id. This can be used as a substitute for the slug segment in URLs. Doing this guarantees your URLs will survive renaming of the repository by its owner, or even transfer of the repository to a different user.
     */
    uuid?: string;
    /**
     * The concatenation of the repository owner's username and the slugified name, e.g. "evzijst/interruptingcow". This is the same string used in Bitbucket URLs.
     */
    full_name?: string;
    is_private?: boolean;
    parent?: Repository;
    scm?: "git";
    owner?: Account;
    name?: string;
    description?: string;
    created_on?: string;
    updated_on?: string;
    size?: number;
    language?: string;
    /**
  *
  The issue tracker for this repository is enabled. Issue Tracker
  features are not supported for repositories in workspaces
  administered through admin.atlassian.com.
  
  */
    has_issues?: boolean;
    /**
  *
  The wiki for this repository is enabled. Wiki
  features are not supported for repositories in workspaces
  administered through admin.atlassian.com.
  
  */
    has_wiki?: boolean;
    /**
  *
  Controls the rules for forking this repository.
  
  * **allow_forks**: unrestricted forking
  * **no_public_forks**: restrict forking to private forks (forks cannot
    be made public later)
  * **no_forks**: deny all forking
  
  */
    fork_policy?: "allow_forks" | "no_public_forks" | "no_forks";
    project?: Project;
    mainbranch?: Branch;
    [x: string]: any;
};
//# sourceMappingURL=Repository.d.ts.map