/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { AccountAsResponse } from "../definitions/AccountAsResponse";
import { ProjectAsResponse } from "../definitions/ProjectAsResponse";
import { BranchAsResponse } from "../definitions/BranchAsResponse";
import { WorkspaceAsResponse } from "../definitions/WorkspaceAsResponse";
import { LinkAsResponse } from "../definitions/LinkAsResponse";
export declare type RepositoryAsResponse = ObjectAsResponse & {
    links?: {
        self?: LinkAsResponse;
        html?: LinkAsResponse;
        avatar?: LinkAsResponse;
        pullrequests?: LinkAsResponse;
        commits?: LinkAsResponse;
        forks?: LinkAsResponse;
        watchers?: LinkAsResponse;
        branches?: LinkAsResponse;
        tags?: LinkAsResponse;
        downloads?: LinkAsResponse;
        source?: LinkAsResponse;
        snippets?: LinkAsResponse;
        hooks?: LinkAsResponse;
        clone?: LinkAsResponse[];
        [x: string]: any;
    };
    /**
     * The repository's immutable id. This can be used as a substitute for the slug segment in URLs. Doing this guarantees your URLs will survive renaming of the repository by its owner, or even transfer of the repository to a different user.
     */
    uuid?: string;
    /**
     * The concatenation of the repository owner's username and the slugified name, e.g. "evzijst/interruptingcow". This is the same string used in Bitbucket URLs.
     */
    full_name?: string;
    is_private?: boolean;
    parent?: RepositoryAsResponse;
    scm?: "git";
    website?: string | null;
    owner?: AccountAsResponse;
    name?: string;
    description?: string;
    created_on?: string;
    updated_on?: string;
    size?: number;
    language?: string;
    has_issues?: boolean;
    has_wiki?: boolean;
    override_settings?: {
        branching_model?: boolean;
        default_merge_strategy?: boolean;
        branch_restrictions?: boolean;
    };
    /**
      *
      Controls the rules for forking this repository.
       
      * **allow_forks**: unrestricted forking
      * **no_public_forks**: restrict forking to private forks (forks cannot
      be made public later)
      * **no_forks**: deny all forking
       
      */
    fork_policy?: "allow_forks" | "no_public_forks" | "no_forks";
    project?: ProjectAsResponse;
    mainbranch?: BranchAsResponse | null;
    workspace?: WorkspaceAsResponse;
    slug?: string;
    [x: string]: any;
};
//# sourceMappingURL=RepositoryAsResponse.d.ts.map