/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { Object } from "../definitions/Object";
export declare type SshKey = Object & {
    /**
     * The SSH key's immutable ID.
     */
    uuid?: string;
    /**
     * The SSH public key value in OpenSSH format.
     */
    key?: string;
    /**
     * The comment parsed from the SSH key (if present)
     */
    comment?: string;
    /**
     * The user-defined label for the SSH key
     */
    label?: string;
    created_on?: string;
    last_used?: string | null;
    links?: {
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
    };
    [x: string]: any;
};
//# sourceMappingURL=SshKey.d.ts.map