/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { Object } from "../definitions/Object";
import { Commit } from "../definitions/Commit";
import { Author } from "../definitions/Author";
export declare type Tag = Object & {
    links?: {
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        commits?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        html?: {
            href?: string;
            name?: string;
        };
    };
    /**
     * The name of the ref.
     */
    name?: string;
    target?: Commit;
    /**
     * The message associated with the tag, if available.
     */
    message?: string;
    /**
     * The date that the tag was created, if available
     */
    date?: string;
    tagger?: Author;
    [x: string]: any;
};
//# sourceMappingURL=Tag.d.ts.map