/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
import { CommitAsResponse } from "../definitions/CommitAsResponse";
import { AuthorAsResponse } from "../definitions/AuthorAsResponse";
export declare type TagAsResponse = ObjectAsResponse & {
    links?: {
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        commits?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        html?: {
            href?: string;
            name?: string;
        };
    };
    /**
     * The name of the ref.
     */
    name?: string;
    target?: CommitAsResponse;
    /**
     * The message associated with the tag, if available.
     */
    message?: string;
    /**
     * The date that the tag was created, if available
     */
    date?: string;
    tagger?: AuthorAsResponse;
    [x: string]: any;
};
//# sourceMappingURL=TagAsResponse.d.ts.map