/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { AccountAsResponse } from "../definitions/AccountAsResponse";
import { UserLinksAsResponse } from "../definitions/UserLinksAsResponse";
export declare type UserAsResponse = AccountAsResponse & {
    links?: UserLinksAsResponse;
    /**
     * The user's Atlassian account ID.
     */
    account_id?: string;
    /**
     * The status of the account. Currently the only possible value is "active", but more values may be added in the future.
     */
    account_status?: string;
    has_2fa_enabled?: boolean;
    /**
     * Account name defined by the owner. Should be used instead of the "username" field. Note that "nickname" cannot be used in place of "username" in URLs and queries, as "nickname" is not guaranteed to be unique.
     */
    nickname?: string;
    is_staff?: boolean;
    [x: string]: any;
};
//# sourceMappingURL=UserAsResponse.d.ts.map