/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ObjectAsResponse } from "../definitions/ObjectAsResponse";
export declare type WorkspaceAsResponse = ObjectAsResponse & {
    links?: {
        /**
         * A link to a resource related to this object.
         */
        avatar?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        html?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        members?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        owners?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        projects?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        repositories?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        snippets?: {
            href?: string;
            name?: string;
        };
        /**
         * A link to a resource related to this object.
         */
        self?: {
            href?: string;
            name?: string;
        };
    };
    /**
     * The workspace's immutable id.
     */
    uuid?: string;
    /**
     * The name of the workspace.
     */
    name?: string;
    /**
     * The short label that identifies this workspace.
     */
    slug?: string;
    /**
  * Indicates whether the workspace is publicly accessible, or whether it is
  private to the members and consequently only visible to members.
  */
    is_private?: boolean;
    /**
     * Indicates whether the workspace enforces private content, or whether it allows public content.
     */
    is_privacy_enforced?: boolean;
    /**
  * Controls the rules for forking repositories within this workspace.
  
  * **allow_forks**: unrestricted forking
  * **internal_only**: prevents forking of private repositories outside the workspace or to public repositories
  
  */
    forking_mode?: "allow_forks" | "internal_only";
    created_on?: string;
    updated_on?: string;
    [x: string]: any;
};
//# sourceMappingURL=WorkspaceAsResponse.d.ts.map