/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { ParticipantAsResponse } from "../../../definitions/ParticipantAsResponse";
import { ErrorAsResponse } from "../../../definitions/ErrorAsResponse";
import { ErrorStrategyOption } from "../../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
export interface ApproveRepositoryCommitRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * The commit's SHA1.
     */
    commit: string;
    /**
  * This can either be the repository slug or the UUID of the repository,
  surrounded by curly-braces, for example: `{repository UUID}`.
  
  */
    repo_slug: string;
    /**
  * This can either be the workspace ID (slug) or the workspace UUID
  surrounded by curly-braces, for example: `{workspace UUID}`.
  
  */
    workspace: string;
}
declare type ApproveRepositoryCommitResponseOKType = ParticipantAsResponse;
export interface ApproveRepositoryCommitResponseOK extends ApproveRepositoryCommitResponseOKType {
}
declare type ApproveRepositoryCommitResponseErrorType = ErrorAsResponse;
export interface ApproveRepositoryCommitResponseError extends ApproveRepositoryCommitResponseErrorType {
}
export interface RedactRepositoryCommitApprovalRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * The commit's SHA1.
     */
    commit: string;
    /**
  * This can either be the repository slug or the UUID of the repository,
  surrounded by curly-braces, for example: `{repository UUID}`.
  
  */
    repo_slug: string;
    /**
  * This can either be the workspace ID (slug) or the workspace UUID
  surrounded by curly-braces, for example: `{workspace UUID}`.
  
  */
    workspace: string;
}
export declare type RedactRepositoryCommitApprovalResponseOK = undefined;
declare type RedactRepositoryCommitApprovalResponseErrorType = ErrorAsResponse;
export interface RedactRepositoryCommitApprovalResponseError extends RedactRepositoryCommitApprovalResponseErrorType {
}
export {};
//# sourceMappingURL=approval.d.ts.map