/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { PaginatedCommitCommentsAsResponse } from "../../../definitions/PaginatedCommitCommentsAsResponse";
import { ErrorStrategyOption } from "../../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
import { CommitCommentAsResponse } from "../../../definitions/CommitCommentAsResponse";
export interface GetRepositoryCommitCommentsRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * The commit's SHA1.
     */
    commit: string;
    /**
  * This can either be the repository slug or the UUID of the repository,
  surrounded by curly-braces, for example: `{repository UUID}`.
  
  */
    repo_slug: string;
    /**
  * This can either be the workspace ID (slug) or the workspace UUID
  surrounded by curly-braces, for example: `{workspace UUID}`.
  
  */
    workspace: string;
    /**
  * Query string to narrow down the response as per
  [filtering and sorting](/cloud/bitbucket/rest/intro/#filtering).
   Example:`deleted=true`
  */
    q?: string;
    /**
  * Field by which the results should be sorted as per
  [filtering and sorting](/cloud/bitbucket/rest/intro/#filtering).
  
  */
    sort?: string;
}
declare type GetRepositoryCommitCommentsResponseOKType = PaginatedCommitCommentsAsResponse;
export interface GetRepositoryCommitCommentsResponseOK extends GetRepositoryCommitCommentsResponseOKType {
}
export declare type GetRepositoryCommitCommentsResponseError = undefined;
export interface GetRepositoryCommitCommentRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * The id of the comment.
     */
    comment_id: number;
    /**
     * The commit's SHA1.
     */
    commit: string;
    /**
  * This can either be the repository slug or the UUID of the repository,
  surrounded by curly-braces, for example: `{repository UUID}`.
  
  */
    repo_slug: string;
    /**
  * This can either be the workspace ID (slug) or the workspace UUID
  surrounded by curly-braces, for example: `{workspace UUID}`.
  
  */
    workspace: string;
}
declare type GetRepositoryCommitCommentResponseOKType = CommitCommentAsResponse;
export interface GetRepositoryCommitCommentResponseOK extends GetRepositoryCommitCommentResponseOKType {
}
export declare type GetRepositoryCommitCommentResponseError = undefined;
export {};
//# sourceMappingURL=comment.d.ts.map