/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { PaginatedDeploymentsAsResponse } from "../../definitions/PaginatedDeploymentsAsResponse";
import { ErrorStrategyOption } from "../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
import { DeploymentAsResponse } from "../../definitions/DeploymentAsResponse";
import { ErrorAsResponse } from "../../definitions/ErrorAsResponse";
export interface GetRepositoryDeploymentsRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * This can either be the workspace ID (slug) or the workspace UUID surrounded by curly-braces, for example `{workspace UUID}`.
     */
    workspace: string;
    /**
     * The repository.
     */
    repo_slug: string;
}
declare type GetRepositoryDeploymentsResponseOKType = PaginatedDeploymentsAsResponse;
export interface GetRepositoryDeploymentsResponseOK extends GetRepositoryDeploymentsResponseOKType {
}
export declare type GetRepositoryDeploymentsResponseError = undefined;
export interface GetRepositoryDeploymentRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * This can either be the workspace ID (slug) or the workspace UUID surrounded by curly-braces, for example `{workspace UUID}`.
     */
    workspace: string;
    /**
     * The repository.
     */
    repo_slug: string;
    /**
     * The deployment UUID.
     */
    deployment_uuid: string;
}
declare type GetRepositoryDeploymentResponseOKType = DeploymentAsResponse;
export interface GetRepositoryDeploymentResponseOK extends GetRepositoryDeploymentResponseOKType {
}
declare type GetRepositoryDeploymentResponseErrorType = ErrorAsResponse;
export interface GetRepositoryDeploymentResponseError extends GetRepositoryDeploymentResponseErrorType {
}
export {};
//# sourceMappingURL=deployment.d.ts.map