/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { PipelinesConfigAsResponse } from "../../../definitions/PipelinesConfigAsResponse";
import { ErrorStrategyOption } from "../../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
export interface UpdateRepositoryPipelineConfigurationRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * This can either be the workspace ID (slug) or the workspace UUID surrounded by curly-braces, for example: {workspace UUID}.
     */
    workspace: string;
    /**
     * The repository.
     */
    repo_slug: string;
    /**
     * The updated repository pipelines configuration.
     */
    body: {
        /**
         * Whether Pipelines is enabled for the repository.
         */
        enabled: boolean;
    };
}
export interface UpdateRepositoryPipelineConfigurationResponseOK extends PipelinesConfigAsResponse {
}
export declare type UpdateRepositoryPipelineConfigurationResponseError = undefined;
export interface RetrieveRepositoryPipelineConfigurationRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * The account.
     */
    workspace: string;
    /**
     * The repository.
     */
    repo_slug: string;
}
declare type RetrieveRepositoryPipelineConfigurationResponseOKType = PipelinesConfigAsResponse;
export interface RetrieveRepositoryPipelineConfigurationResponseOK extends RetrieveRepositoryPipelineConfigurationResponseOKType {
}
export declare type RetrieveRepositoryPipelineConfigurationResponseError = undefined;
export {};
//# sourceMappingURL=configuration.d.ts.map