/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { PipelineBuildNumberAsResponse } from "../../../../definitions/PipelineBuildNumberAsResponse";
import { ErrorAsResponse } from "../../../../definitions/ErrorAsResponse";
import { ErrorStrategyOption } from "../../../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
export interface UpdateRepositoryPipelineConfigurationBuildNumberRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * This can either be the workspace ID (slug) or the workspace UUID surrounded by curly-braces, for example: {workspace UUID}.
     */
    workspace: string;
    /**
     * The repository.
     */
    repo_slug: string;
    /**
     * The build number to update.
     */
    body: {
        /**
         * The next number that will be used as build number.
         */
        next: number;
    };
}
export interface UpdateRepositoryPipelineConfigurationBuildNumberResponseOK extends PipelineBuildNumberAsResponse {
}
export interface UpdateRepositoryPipelineConfigurationBuildNumberResponseError extends ErrorAsResponse {
}
//# sourceMappingURL=build.d.ts.map