/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { PaginatedPipelineStepsAsResponse } from "../../../definitions/PaginatedPipelineStepsAsResponse";
import { ErrorStrategyOption } from "../../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
import { PipelineStepAsResponse } from "../../../definitions/PipelineStepAsResponse";
import { ErrorAsResponse } from "../../../definitions/ErrorAsResponse";
export interface FindRepositoryStepsForPipelineRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * This can either be the workspace ID (slug) or the workspace UUID surrounded by curly-braces, for example `{workspace UUID}`.
     */
    workspace: string;
    /**
     * The repository.
     */
    repo_slug: string;
    /**
     * The UUID of the pipeline.
     */
    pipeline_uuid: string;
}
declare type FindRepositoryStepsForPipelineResponseOKType = PaginatedPipelineStepsAsResponse;
export interface FindRepositoryStepsForPipelineResponseOK extends FindRepositoryStepsForPipelineResponseOKType {
}
export declare type FindRepositoryStepsForPipelineResponseError = undefined;
export interface RetrieveRepositoryStepForPipelineRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * This can either be the workspace ID (slug) or the workspace UUID surrounded by curly-braces, for example `{workspace UUID}`.
     */
    workspace: string;
    /**
     * The repository.
     */
    repo_slug: string;
    /**
     * The UUID of the pipeline.
     */
    pipeline_uuid: string;
    /**
     * The UUID of the step.
     */
    step_uuid: string;
}
declare type RetrieveRepositoryStepForPipelineResponseOKType = PipelineStepAsResponse;
export interface RetrieveRepositoryStepForPipelineResponseOK extends RetrieveRepositoryStepForPipelineResponseOKType {
}
declare type RetrieveRepositoryStepForPipelineResponseErrorType = ErrorAsResponse;
export interface RetrieveRepositoryStepForPipelineResponseError extends RetrieveRepositoryStepForPipelineResponseErrorType {
}
export {};
//# sourceMappingURL=step.d.ts.map