/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { PaginatedChangesetAsResponse } from "../../../definitions/PaginatedChangesetAsResponse";
import { ErrorAsResponse } from "../../../definitions/ErrorAsResponse";
import { ErrorStrategyOption } from "../../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
export interface GetRepositoryPullrequestCommitsRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * The id of the pull request.
     */
    pull_request_id: number;
    /**
  * This can either be the repository slug or the UUID of the repository,
  surrounded by curly-braces, for example: `{repository UUID}`.
  
  */
    repo_slug: string;
    /**
  * This can either be the workspace ID (slug) or the workspace UUID
  surrounded by curly-braces, for example: `{workspace UUID}`.
  
  */
    workspace: string;
}
declare type GetRepositoryPullrequestCommitsResponseOKType = PaginatedChangesetAsResponse;
export interface GetRepositoryPullrequestCommitsResponseOK extends GetRepositoryPullrequestCommitsResponseOKType {
}
declare type GetRepositoryPullrequestCommitsResponseErrorType = ErrorAsResponse & ErrorAsResponse;
export interface GetRepositoryPullrequestCommitsResponseError extends GetRepositoryPullrequestCommitsResponseErrorType {
}
export {};
//# sourceMappingURL=commit.d.ts.map