/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { PaginatedAccountsAsResponse } from "../../../definitions/PaginatedAccountsAsResponse";
import { ErrorAsResponse } from "../../../definitions/ErrorAsResponse";
import { ErrorStrategyOption } from "../../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
import { AccountAsResponse } from "../../../definitions/AccountAsResponse";
export interface GetRepositoryDefaultReviewersRequest extends HeadersOption, ErrorStrategyOption {
    /**
  * This can either be the repository slug or the UUID of the repository,
  surrounded by curly-braces, for example: `{repository UUID}`.
  
  */
    repo_slug: string;
    /**
  * This can either be the workspace ID (slug) or the workspace UUID
  surrounded by curly-braces, for example: `{workspace UUID}`.
  
  */
    workspace: string;
}
declare type GetRepositoryDefaultReviewersResponseOKType = PaginatedAccountsAsResponse;
export interface GetRepositoryDefaultReviewersResponseOK extends GetRepositoryDefaultReviewersResponseOKType {
}
declare type GetRepositoryDefaultReviewersResponseErrorType = ErrorAsResponse;
export interface GetRepositoryDefaultReviewersResponseError extends GetRepositoryDefaultReviewersResponseErrorType {
}
export interface GetRepositoryDefaultReviewerRequest extends HeadersOption, ErrorStrategyOption {
    /**
  * This can either be the repository slug or the UUID of the repository,
  surrounded by curly-braces, for example: `{repository UUID}`.
  
  */
    repo_slug: string;
    /**
  * This can either be the username or the UUID of the default reviewer,
  surrounded by curly-braces, for example: `{account UUID}`.
  
  */
    target_username: string;
    /**
  * This can either be the workspace ID (slug) or the workspace UUID
  surrounded by curly-braces, for example: `{workspace UUID}`.
  
  */
    workspace: string;
}
declare type GetRepositoryDefaultReviewerResponseOKType = AccountAsResponse;
export interface GetRepositoryDefaultReviewerResponseOK extends GetRepositoryDefaultReviewerResponseOKType {
}
declare type GetRepositoryDefaultReviewerResponseErrorType = ErrorAsResponse & ErrorAsResponse;
export interface GetRepositoryDefaultReviewerResponseError extends GetRepositoryDefaultReviewerResponseErrorType {
}
export interface AddRepositoryDefaultReviewerRequest extends HeadersOption, ErrorStrategyOption {
    /**
  * This can either be the repository slug or the UUID of the repository,
  surrounded by curly-braces, for example: `{repository UUID}`.
  
  */
    repo_slug: string;
    /**
  * This can either be the username or the UUID of the default reviewer,
  surrounded by curly-braces, for example: `{account UUID}`.
  
  */
    target_username: string;
    /**
  * This can either be the workspace ID (slug) or the workspace UUID
  surrounded by curly-braces, for example: `{workspace UUID}`.
  
  */
    workspace: string;
}
declare type AddRepositoryDefaultReviewerResponseOKType = AccountAsResponse;
export interface AddRepositoryDefaultReviewerResponseOK extends AddRepositoryDefaultReviewerResponseOKType {
}
declare type AddRepositoryDefaultReviewerResponseErrorType = ErrorAsResponse & ErrorAsResponse & ErrorAsResponse;
export interface AddRepositoryDefaultReviewerResponseError extends AddRepositoryDefaultReviewerResponseErrorType {
}
export interface RemoveRepositoryDefaultReviewerRequest extends HeadersOption, ErrorStrategyOption {
    /**
  * This can either be the repository slug or the UUID of the repository,
  surrounded by curly-braces, for example: `{repository UUID}`.
  
  */
    repo_slug: string;
    /**
  * This can either be the username or the UUID of the default reviewer,
  surrounded by curly-braces, for example: `{account UUID}`.
  
  */
    target_username: string;
    /**
  * This can either be the workspace ID (slug) or the workspace UUID
  surrounded by curly-braces, for example: `{workspace UUID}`.
  
  */
    workspace: string;
}
export declare type RemoveRepositoryDefaultReviewerResponseOK = undefined;
declare type RemoveRepositoryDefaultReviewerResponseErrorType = ErrorAsResponse & ErrorAsResponse;
export interface RemoveRepositoryDefaultReviewerResponseError extends RemoveRepositoryDefaultReviewerResponseErrorType {
}
export {};
//# sourceMappingURL=default.d.ts.map