/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { AccountAsResponse } from "../definitions/AccountAsResponse";
import { ErrorAsResponse } from "../definitions/ErrorAsResponse";
import { ErrorStrategyOption } from "../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
import { PaginatedEmailsAsResponse } from "../definitions/PaginatedEmailsAsResponse";
import { EmailAsResponse } from "../definitions/EmailAsResponse";
export interface GetCurrentUserRequest extends HeadersOption, ErrorStrategyOption {
}
declare type GetCurrentUserResponseOKType = AccountAsResponse;
export interface GetCurrentUserResponseOK extends GetCurrentUserResponseOKType {
}
declare type GetCurrentUserResponseErrorType = ErrorAsResponse;
export interface GetCurrentUserResponseError extends GetCurrentUserResponseErrorType {
}
export interface GetCurrentUserEmailsRequest extends HeadersOption, ErrorStrategyOption {
}
declare type GetCurrentUserEmailsResponseOKType = PaginatedEmailsAsResponse;
export interface GetCurrentUserEmailsResponseOK extends GetCurrentUserEmailsResponseOKType {
}
declare type GetCurrentUserEmailsResponseErrorType = ErrorAsResponse;
export interface GetCurrentUserEmailsResponseError extends GetCurrentUserEmailsResponseErrorType {
}
export interface GetUserRequest extends HeadersOption, ErrorStrategyOption {
    /**
  * This can either be an Atlassian Account ID OR the UUID of the account,
  surrounded by curly-braces, for example: `{account UUID}`.
  
  */
    selected_user: string;
}
declare type GetUserResponseOKType = AccountAsResponse;
export interface GetUserResponseOK extends GetUserResponseOKType {
}
declare type GetUserResponseErrorType = ErrorAsResponse;
export interface GetUserResponseError extends GetUserResponseErrorType {
}
export interface GetCurrentUserEmailRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * Email address of the user.
     */
    email: string;
}
declare type GetCurrentUserEmailResponseOKType = EmailAsResponse;
export interface GetCurrentUserEmailResponseOK extends GetCurrentUserEmailResponseOKType {
}
declare type GetCurrentUserEmailResponseErrorType = ErrorAsResponse;
export interface GetCurrentUserEmailResponseError extends GetCurrentUserEmailResponseErrorType {
}
export {};
//# sourceMappingURL=user.d.ts.map