/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { PaginatedRepositoryPermissionsAsResponse } from "../../definitions/PaginatedRepositoryPermissionsAsResponse";
import { ErrorStrategyOption } from "../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
import { PaginatedWorkspaceMembershipsAsResponse } from "../../definitions/PaginatedWorkspaceMembershipsAsResponse";
import { ErrorAsResponse } from "../../definitions/ErrorAsResponse";
export interface GetCurrentUserRepositoryPermissionsRequest extends HeadersOption, ErrorStrategyOption {
    /**
  *
  Query string to narrow down the response as per
  [filtering and sorting](/cloud/bitbucket/rest/intro/#filtering).
   Example:`permission="admin"`
  */
    q?: string;
    /**
  *
  Name of a response property sort the result by as per
  [filtering and sorting](/cloud/bitbucket/rest/intro/#filtering).
  */
    sort?: string;
}
declare type GetCurrentUserRepositoryPermissionsResponseOKType = PaginatedRepositoryPermissionsAsResponse;
export interface GetCurrentUserRepositoryPermissionsResponseOK extends GetCurrentUserRepositoryPermissionsResponseOKType {
}
export declare type GetCurrentUserRepositoryPermissionsResponseError = undefined;
export interface GetCurrentUserWorkspaceMembershipsRequest extends HeadersOption, ErrorStrategyOption {
    /**
  *
  Query string to narrow down the response. See
  [filtering and sorting](/cloud/bitbucket/rest/intro/#filtering) for details.
   Example:`permission="owner"`
  */
    q?: string;
    /**
  *
  Name of a response property to sort results. See
  [filtering and sorting](/cloud/bitbucket/rest/intro/#sorting-query-results)
  for details.
  
  */
    sort?: string;
}
declare type GetCurrentUserWorkspaceMembershipsResponseOKType = PaginatedWorkspaceMembershipsAsResponse;
export interface GetCurrentUserWorkspaceMembershipsResponseOK extends GetCurrentUserWorkspaceMembershipsResponseOKType {
}
declare type GetCurrentUserWorkspaceMembershipsResponseErrorType = ErrorAsResponse;
export interface GetCurrentUserWorkspaceMembershipsResponseError extends GetCurrentUserWorkspaceMembershipsResponseErrorType {
}
export {};
//# sourceMappingURL=permission.d.ts.map