/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { SearchResultPageAsResponse } from "../../../definitions/SearchResultPageAsResponse";
import { ErrorAsResponse } from "../../../definitions/ErrorAsResponse";
import { ErrorStrategyOption } from "../../../errorStrategy";
import { HeadersOption } from "@managed-api/commons-core";
export interface SearchCodeInWorkspaceProjectsRequest extends HeadersOption, ErrorStrategyOption {
    /**
     * The workspace to search in; either the slug or the UUID in curly braces
     */
    workspace: string;
    /**
     * The search query
     */
    search_query: string;
    /**
     * Which page of the search results to retrieve
     */
    page?: number;
    /**
     * How many search results to retrieve per page
     */
    pagelen?: number;
}
declare type SearchCodeInWorkspaceProjectsResponseOKType = SearchResultPageAsResponse;
export interface SearchCodeInWorkspaceProjectsResponseOK extends SearchCodeInWorkspaceProjectsResponseOKType {
}
declare type SearchCodeInWorkspaceProjectsResponseErrorType = ErrorAsResponse & ErrorAsResponse & ErrorAsResponse;
export interface SearchCodeInWorkspaceProjectsResponseError extends SearchCodeInWorkspaceProjectsResponseErrorType {
}
export {};
//# sourceMappingURL=search.d.ts.map